From f82e17b4a6c7fe35c16d45ad9c555d0ad90af2be Mon Sep 17 00:00:00 2001
From: Pino Toscano <ptoscano@redhat.com>
Date: Wed, 14 May 2014 10:24:41 -0400
Subject: [PATCH 027/118] Backport virt-sysprep from libguestfs 1.24

Copy the virt-sysprep code from libguestfs 1.24.x, bringing all the
features of it to libguestfs 1.20.x. This is done as single commit
because cherry-picking individual commits is simply not worth it, and
would require to cherry-pick a big number of commits, possibly bringing
in new features implemented elsewhere, etc.

Move existing files (where possible) or import them from 1.24.x,
adapting the current ocaml-based tools to the updated functions in
mllib.
---
 .gitignore                                         |   8 +-
 Makefile.am                                        |   2 +-
 configure.ac                                       |  17 +-
 mllib/Makefile.am                                  | 164 +++++++++
 mllib/common_utils.ml                              | 410 +++++++++++++++++++++
 mllib/common_utils_tests.ml                        |  80 ++++
 mllib/config.ml.in                                 |  20 +
 mllib/crypt-c.c                                    |  44 +++
 mllib/crypt.ml                                     |  19 +
 mllib/crypt.mli                                    |  22 ++
 mllib/firstboot.ml                                 | 169 +++++++++
 mllib/firstboot.mli                                |  27 ++
 mllib/hostname.ml                                  |  80 ++++
 mllib/hostname.mli                                 |  21 ++
 mllib/password.ml                                  | 142 +++++++
 mllib/password.mli                                 |  35 ++
 mllib/progress-c.c                                 | 106 ++++++
 mllib/progress.ml                                  |  58 +++
 mllib/progress.mli                                 |  19 +
 mllib/random_seed.ml                               |  96 +++++
 mllib/random_seed.mli                              |  21 ++
 mllib/tTY.ml                                       |  19 +
 mllib/tTY.mli                                      |  23 ++
 mllib/tty-c.c                                      |  38 ++
 mllib/urandom.ml                                   |  69 ++++
 mllib/urandom.mli                                  |  26 ++
 po/POTFILES                                        |   5 +-
 po/POTFILES-ml                                     |   9 +-
 resize/Makefile.am                                 |  39 +-
 resize/common_utils.ml                             | 248 -------------
 resize/common_utils_tests.ml                       |  78 ----
 resize/progress-c.c                                | 106 ------
 resize/progress.ml                                 |  58 ---
 resize/progress.mli                                |  19 -
 resize/resize.ml                                   |   3 +-
 resize/tTY.ml                                      |  19 -
 resize/tTY.mli                                     |  23 --
 resize/tty-c.c                                     |  38 --
 sparsify/Makefile.am                               |  20 +-
 sparsify/sparsify.ml                               |   1 +
 sysprep/Makefile.am                                |  55 ++-
 sysprep/firstboot.ml                               | 161 --------
 sysprep/firstboot.mli                              |  27 --
 sysprep/main.ml                                    |  31 +-
 sysprep/sysprep_operation.ml                       |  86 +++--
 sysprep/sysprep_operation.mli                      |  25 +-
 sysprep/sysprep_operation_abrt_data.ml             |  17 +-
 sysprep/sysprep_operation_bash_history.ml          |  21 +-
 sysprep/sysprep_operation_blkid_tab.ml             |  16 +-
 sysprep/sysprep_operation_ca_certificates.ml       |  16 +-
 sysprep/sysprep_operation_crash_data.ml            |  17 +-
 sysprep/sysprep_operation_cron_spool.ml            |  18 +-
 sysprep/sysprep_operation_dhcp_client_state.ml     |  16 +-
 sysprep/sysprep_operation_dhcp_server_state.ml     |  16 +-
 sysprep/sysprep_operation_dovecot_data.ml          |  16 +-
 sysprep/sysprep_operation_firewall_rules.ml        |  57 +++
 sysprep/sysprep_operation_firstboot.ml             |  61 ++-
 sysprep/sysprep_operation_flag_reconfiguration.ml  |  17 +-
 sysprep/sysprep_operation_hostname.ml              |  89 ++---
 sysprep/sysprep_operation_kerberos_data.ml         |  16 +-
 sysprep/sysprep_operation_logfiles.ml              |  29 +-
 sysprep/sysprep_operation_lvm_uuids.ml             |  17 +-
 sysprep/sysprep_operation_machine_id.ml            |  17 +-
 sysprep/sysprep_operation_mail_spool.ml            |  16 +-
 sysprep/sysprep_operation_net_hostname.ml          |  17 +-
 sysprep/sysprep_operation_net_hwaddr.ml            |  17 +-
 sysprep/sysprep_operation_pacct_log.ml             |  17 +-
 sysprep/sysprep_operation_package_manager_cache.ml |  25 +-
 sysprep/sysprep_operation_pam_data.ml              |  16 +-
 sysprep/sysprep_operation_password.ml              | 162 ++++++++
 sysprep/sysprep_operation_puppet_data_log.ml       |  16 +-
 sysprep/sysprep_operation_random_seed.ml           |  44 +--
 sysprep/sysprep_operation_rhn_systemid.ml          |  16 +-
 sysprep/sysprep_operation_rpm_db.ml                |  17 +-
 sysprep/sysprep_operation_samba_db_log.ml          |  16 +-
 sysprep/sysprep_operation_script.ml                |  39 +-
 sysprep/sysprep_operation_smolt_uuid.ml            |  16 +-
 sysprep/sysprep_operation_ssh_hostkeys.ml          |  17 +-
 sysprep/sysprep_operation_ssh_userdir.ml           |  21 +-
 sysprep/sysprep_operation_sssd_db_log.ml           |  16 +-
 sysprep/sysprep_operation_tmp_files.ml             |  52 +++
 sysprep/sysprep_operation_udev_persistent_net.ml   |  17 +-
 sysprep/sysprep_operation_user_account.ml          |  21 +-
 sysprep/sysprep_operation_utmp.ml                  |  17 +-
 sysprep/sysprep_operation_yum_uuid.ml              |  17 +-
 tests/guests/guest-aux/make-debian-img.sh          |   1 +
 tests/guests/guest-aux/make-ubuntu-img.sh          |   1 +
 87 files changed, 2536 insertions(+), 1320 deletions(-)
 create mode 100644 mllib/Makefile.am
 create mode 100644 mllib/common_utils.ml
 create mode 100644 mllib/common_utils_tests.ml
 create mode 100644 mllib/config.ml.in
 create mode 100644 mllib/crypt-c.c
 create mode 100644 mllib/crypt.ml
 create mode 100644 mllib/crypt.mli
 create mode 100644 mllib/firstboot.ml
 create mode 100644 mllib/firstboot.mli
 create mode 100644 mllib/hostname.ml
 create mode 100644 mllib/hostname.mli
 create mode 100644 mllib/password.ml
 create mode 100644 mllib/password.mli
 create mode 100644 mllib/progress-c.c
 create mode 100644 mllib/progress.ml
 create mode 100644 mllib/progress.mli
 create mode 100644 mllib/random_seed.ml
 create mode 100644 mllib/random_seed.mli
 create mode 100644 mllib/tTY.ml
 create mode 100644 mllib/tTY.mli
 create mode 100644 mllib/tty-c.c
 create mode 100644 mllib/urandom.ml
 create mode 100644 mllib/urandom.mli
 delete mode 100644 resize/common_utils.ml
 delete mode 100644 resize/common_utils_tests.ml
 delete mode 100644 resize/progress-c.c
 delete mode 100644 resize/progress.ml
 delete mode 100644 resize/progress.mli
 delete mode 100644 resize/tTY.ml
 delete mode 100644 resize/tTY.mli
 delete mode 100644 resize/tty-c.c
 delete mode 100644 sysprep/firstboot.ml
 delete mode 100644 sysprep/firstboot.mli
 create mode 100644 sysprep/sysprep_operation_firewall_rules.ml
 create mode 100644 sysprep/sysprep_operation_password.ml
 create mode 100644 sysprep/sysprep_operation_tmp_files.ml

diff --git a/.gitignore b/.gitignore
index c005329..f379b5e 100644
--- a/.gitignore
+++ b/.gitignore
@@ -239,6 +239,12 @@ Makefile.in
 /m4/ltversion.m4
 /maint.mk
 /missing
+/mllib/.depend
+/mllib/common_gettext.ml
+/mllib/common_utils_tests
+/mllib/config.ml
+/mllib/dummy
+/mllib/libdir.ml
 /ocaml/bindtests.bc
 /ocaml/bindtests.opt
 /ocaml/bindtests.ml
@@ -338,8 +344,6 @@ Makefile.in
 /rescue/virt-rescue
 /rescue/virt-rescue.1
 /resize/.depend
-/resize/common_gettext.ml
-/resize/common_utils_tests
 /resize/stamp-virt-resize.pod
 /resize/virt-resize
 /resize/virt-resize.1
diff --git a/Makefile.am b/Makefile.am
index b3fe403..fab3c13 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -105,7 +105,7 @@ SUBDIRS += csharp
 
 # OCaml tools.
 if HAVE_OCAML
-SUBDIRS += resize sparsify sysprep
+SUBDIRS += mllib resize sparsify sysprep
 endif
 
 # Perl tools.
diff --git a/configure.ac b/configure.ac
index 57bef84..2f89a61 100644
--- a/configure.ac
+++ b/configure.ac
@@ -969,10 +969,13 @@ AS_IF([test "x$OCAMLC" != "xno"],[
 
     dnl Write a common gettext module used by each OCaml tool.
     dnl If OCaml gettext is not available then we write dummy functions.
-    AC_MSG_NOTICE([creating resize/common_gettext.ml])
-    rm -f resize/common_gettext.ml
+    AC_MSG_NOTICE([creating mllib/common_gettext.ml])
+    rm -f mllib/common_gettext.ml
+    # If we're building in a different directory, then 'mllib/' might
+    # not exist yet, so create it:
+    mkdir -p mllib
 
-    cat <<EOF > resize/common_gettext.ml
+    cat <<EOF > mllib/common_gettext.ml
 (* This file is generated automatically by ./configure. *)
 
 (** Gettext functions for OCaml virt tools.
@@ -1010,7 +1013,7 @@ EOF
 
     if test "x$OCAML_PKG_gettext" != "xno"; then
         # ocaml-gettext available: real module.
-        cat <<EOF >>resize/common_gettext.ml
+        cat <<EOF >>mllib/common_gettext.ml
 module Gettext = Gettext.Program (
   struct
     let textdomain = "$PACKAGE_NAME"
@@ -1022,7 +1025,7 @@ module Gettext = Gettext.Program (
 EOF
     else
         # No gettext: module containing dummy gettext functions.
-        cat <<EOF >>resize/common_gettext.ml
+        cat <<EOF >>mllib/common_gettext.ml
 module Gettext = struct
   external s_ : string -> string = "%identity"
   external f_ : ('a, 'b, 'c, 'd, 'e, 'f) format6
@@ -1038,7 +1041,7 @@ end
 EOF
     fi
 
-    chmod -w resize/common_gettext.ml
+    chmod -w mllib/common_gettext.ml
 ])
 AM_CONDITIONAL([HAVE_OCAML_PKG_GETTEXT],
     [test "x$OCAMLC" != "xno" && test "x$OCAMLFIND" != "xno" && test "x$OCAML_PKG_gettext" != "xno"])
@@ -1551,6 +1554,8 @@ AC_CONFIG_FILES([Makefile
                  java/examples/Makefile
                  lua/Makefile
                  lua/examples/Makefile
+                 mllib/Makefile
+                 mllib/config.ml
                  ocaml/META
                  ocaml/Makefile
                  ocaml/examples/Makefile
diff --git a/mllib/Makefile.am b/mllib/Makefile.am
new file mode 100644
index 0000000..14b9a4f
--- /dev/null
+++ b/mllib/Makefile.am
@@ -0,0 +1,164 @@
+# libguestfs OCaml tools common code
+# Copyright (C) 2011-2014 Red Hat Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+include $(top_srcdir)/subdir-rules.mk
+
+EXTRA_DIST = \
+	$(SOURCES)
+
+CLEANFILES = *~ *.cmi *.cmo *.cmx *.cmxa *.o
+
+VPATH += $(top_srcdir)/fish
+
+# Alphabetical order.
+SOURCES = \
+	common_gettext.ml \
+	common_utils.ml \
+	common_utils_tests.ml \
+	config.ml \
+	crypt-c.c \
+	crypt.ml \
+	crypt.mli \
+	firstboot.mli \
+	firstboot.ml \
+	hostname.mli \
+	hostname.ml \
+	password.mli \
+	password.ml \
+	progress-c.c \
+	progress.mli \
+	progress.ml \
+	random_seed.mli \
+	random_seed.ml \
+	tty-c.c \
+	tTY.mli \
+	tTY.ml \
+	urandom.mli \
+	urandom.ml
+
+if HAVE_OCAML
+
+# Notes:
+# - We're not actually building a functioning program here, we're just
+#   linking everything together to check all the modules build OK.
+# - This list must be in dependency order.
+OBJECTS = \
+	$(top_builddir)/fish/guestfish-progress.o \
+	tty-c.o \
+	progress-c.o \
+	crypt-c.o \
+	config.cmx \
+	libdir.cmx \
+	common_gettext.cmx \
+	common_utils.cmx \
+	urandom.cmx \
+	random_seed.cmx \
+	hostname.cmx \
+	firstboot.cmx \
+	tTY.cmx \
+	progress.cmx \
+	crypt.cmx \
+	password.cmx
+
+noinst_SCRIPTS = dummy
+
+# -I $(top_builddir)/src/.libs is a hack which forces corresponding -L
+# option to be passed to gcc, so we don't try linking against an
+# installed copy of libguestfs.
+OCAMLPACKAGES = -package str,unix -I $(top_builddir)/src/.libs -I ../ocaml
+if HAVE_OCAML_PKG_GETTEXT
+OCAMLPACKAGES += -package gettext-stub
+endif
+
+OCAMLCFLAGS = -g -warn-error CDEFLMPSUVYZX $(OCAMLPACKAGES)
+OCAMLOPTFLAGS = $(OCAMLCFLAGS)
+
+OCAMLCLIBS  = \
+	$(LIBXML2_LIBS) -lncurses -lcrypt \
+	-L../src/.libs -lutils \
+	-L../gnulib/lib/.libs -lgnu
+
+dummy: $(OBJECTS)
+	$(OCAMLFIND) ocamlopt $(OCAMLOPTFLAGS) \
+	  mlguestfs.cmxa -linkpkg $^ \
+	  -cclib '$(OCAMLCLIBS)' \
+	  $(OCAML_GCOV_LDFLAGS) \
+	  -o $@
+
+.mli.cmi:
+	$(OCAMLFIND) ocamlc $(OCAMLCFLAGS) -c $< -o $@
+.ml.cmo:
+	$(OCAMLFIND) ocamlc $(OCAMLCFLAGS) -c $< -o $@
+.ml.cmx:
+	$(OCAMLFIND) ocamlopt $(OCAMLOPTFLAGS) -c $< -o $@
+
+# This OCaml module has to be generated by make (configure will put
+# unexpanded prefix macro in).
+
+libdir.ml: Makefile
+	echo 'let libdir = "$(libdir)"' > $@-t
+	mv $@-t $@
+
+# automake will decide we don't need C support in this file.  Really
+# we do, so we have to provide it ourselves.
+
+DEFAULT_INCLUDES = \
+	-I. \
+	-I$(top_builddir) \
+	-I$(shell $(OCAMLC) -where) \
+	-I$(top_srcdir)/src \
+	-I$(top_srcdir)/fish \
+	$(LIBXML2_CFLAGS) \
+	-I$(srcdir)/../gnulib/lib -I../gnulib/lib
+
+.c.o:
+	$(CC) $(CFLAGS) $(PROF_CFLAGS) $(DEFAULT_INCLUDES) -c $< -o $@
+
+# Tests.
+
+check_SCRIPTS = common_utils_tests
+
+common_utils_tests: common_gettext.cmx common_utils.cmx common_utils_tests.cmx
+	$(OCAMLFIND) ocamlopt $(OCAMLOPTFLAGS) \
+	  mlguestfs.cmxa -linkpkg $^ -cclib -lncurses -o $@
+
+TESTS_ENVIRONMENT = $(top_builddir)/run --test
+
+TESTS = common_utils_tests
+
+check-valgrind:
+	$(MAKE) VG="$(top_builddir)/run @VG@" check
+
+# Dependencies.
+depend: .depend
+
+.depend: $(wildcard $(abs_srcdir)/*.mli) $(wildcard $(abs_srcdir)/*.ml)
+	rm -f $@ $@-t
+	$(OCAMLFIND) ocamldep -I ../ocaml -I $(abs_srcdir) $^ | \
+	  $(SED) 's/ *$$//' | \
+	  $(SED) -e :a -e '/ *\\$$/N; s/ *\\\n */ /; ta' | \
+	  $(SED) -e 's,$(abs_srcdir)/,$(builddir)/,g' | \
+	  sort > $@-t
+	mv $@-t $@
+
+-include .depend
+
+endif
+
+DISTCLEANFILES = .depend
+
+.PHONY: depend docs
diff --git a/mllib/common_utils.ml b/mllib/common_utils.ml
new file mode 100644
index 0000000..1bda757
--- /dev/null
+++ b/mllib/common_utils.ml
@@ -0,0 +1,410 @@
+(* Common utilities for OCaml tools in libguestfs.
+ * Copyright (C) 2010-2014 Red Hat Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ *)
+
+open Printf
+
+open Common_gettext.Gettext
+
+module G = Guestfs
+
+let (//) = Filename.concat
+
+let ( +^ ) = Int64.add
+let ( -^ ) = Int64.sub
+let ( *^ ) = Int64.mul
+let ( /^ ) = Int64.div
+let ( &^ ) = Int64.logand
+let ( ~^ ) = Int64.lognot
+
+(* Return 'i' rounded up to the next multiple of 'a'. *)
+let roundup64 i a = let a = a -^ 1L in (i +^ a) &^ (~^ a)
+
+let int_of_le32 str =
+  assert (String.length str = 4);
+  let c0 = Char.code (String.unsafe_get str 0) in
+  let c1 = Char.code (String.unsafe_get str 1) in
+  let c2 = Char.code (String.unsafe_get str 2) in
+  let c3 = Char.code (String.unsafe_get str 3) in
+  Int64.of_int c0 +^
+    (Int64.shift_left (Int64.of_int c1) 8) +^
+    (Int64.shift_left (Int64.of_int c2) 16) +^
+    (Int64.shift_left (Int64.of_int c3) 24)
+
+let le32_of_int i =
+  let c0 = i &^ 0xffL in
+  let c1 = Int64.shift_right (i &^ 0xff00L) 8 in
+  let c2 = Int64.shift_right (i &^ 0xff0000L) 16 in
+  let c3 = Int64.shift_right (i &^ 0xff000000L) 24 in
+  let s = String.create 4 in
+  String.unsafe_set s 0 (Char.unsafe_chr (Int64.to_int c0));
+  String.unsafe_set s 1 (Char.unsafe_chr (Int64.to_int c1));
+  String.unsafe_set s 2 (Char.unsafe_chr (Int64.to_int c2));
+  String.unsafe_set s 3 (Char.unsafe_chr (Int64.to_int c3));
+  s
+
+let output_spaces chan n = for i = 0 to n-1 do output_char chan ' ' done
+
+let wrap ?(chan = stdout) ?(hanging = 0) str =
+  let rec _wrap col str =
+    let n = String.length str in
+    let i = try String.index str ' ' with Not_found -> n in
+    let col =
+      if col+i >= 72 then (
+        output_char chan '\n';
+        output_spaces chan hanging;
+        i+hanging+1
+      ) else col+i+1 in
+    output_string chan (String.sub str 0 i);
+    if i < n then (
+      output_char chan ' ';
+      _wrap col (String.sub str (i+1) (n-(i+1)))
+    )
+  in
+  _wrap 0 str
+
+let string_prefix str prefix =
+  let n = String.length prefix in
+  String.length str >= n && String.sub str 0 n = prefix
+
+let rec string_find s sub =
+  let len = String.length s in
+  let sublen = String.length sub in
+  let rec loop i =
+    if i <= len-sublen then (
+      let rec loop2 j =
+        if j < sublen then (
+          if s.[i+j] = sub.[j] then loop2 (j+1)
+          else -1
+        ) else
+          i (* found *)
+      in
+      let r = loop2 0 in
+      if r = -1 then loop (i+1) else r
+    ) else
+      -1 (* not found *)
+  in
+  loop 0
+
+let rec replace_str s s1 s2 =
+  let len = String.length s in
+  let sublen = String.length s1 in
+  let i = string_find s s1 in
+  if i = -1 then s
+  else (
+    let s' = String.sub s 0 i in
+    let s'' = String.sub s (i+sublen) (len-i-sublen) in
+    s' ^ s2 ^ replace_str s'' s1 s2
+  )
+
+(* Split a string into multiple strings at each separator. *)
+let rec string_nsplit sep str =
+  let len = String.length str in
+  let seplen = String.length sep in
+  let i = string_find str sep in
+  if i = -1 then [str]
+  else (
+    let s' = String.sub str 0 i in
+    let s'' = String.sub str (i+seplen) (len-i-seplen) in
+    s' :: string_nsplit sep s''
+  )
+
+(* Split a string at the first occurrence of the separator, returning
+ * the part before and the part after.  If separator is not found,
+ * return the whole string and an empty string.
+ *)
+let string_split sep str =
+  let len = String.length sep in
+  let seplen = String.length str in
+  let i = string_find str sep in
+
+  if i = -1 then str, ""
+  else (
+    String.sub str 0 i, String.sub str (i + len) (seplen - i - len)
+  )
+
+let string_random8 =
+  let chars = "abcdefghijklmnopqrstuvwxyz0123456789" in
+  fun () ->
+    String.concat "" (
+      List.map (
+        fun _ ->
+          let c = Random.int 36 in
+          let c = chars.[c] in
+          String.make 1 c
+      ) [1;2;3;4;5;6;7;8]
+    )
+
+(* Drop elements from a list while a predicate is true. *)
+let rec dropwhile f = function
+  | [] -> []
+  | x :: xs when f x -> dropwhile f xs
+  | xs -> xs
+
+(* Take elements from a list while a predicate is true. *)
+let rec takewhile f = function
+  | x :: xs when f x -> x :: takewhile f xs
+  | _ -> []
+
+let rec filter_map f = function
+  | [] -> []
+  | x :: xs ->
+      match f x with
+      | Some y -> y :: filter_map f xs
+      | None -> filter_map f xs
+
+let iteri f xs =
+  let rec loop i = function
+    | [] -> ()
+    | x :: xs -> f i x; loop (i+1) xs
+  in
+  loop 0 xs
+
+(* Timestamped progress messages, used for ordinary messages when not
+ * --quiet.
+ *)
+let start_t = Unix.time ()
+let make_message_function ~quiet fs =
+  let p str =
+    if not quiet then (
+      let t = sprintf "%.1f" (Unix.time () -. start_t) in
+      printf "[%6s] %s\n%!" t str
+    )
+  in
+  ksprintf p fs
+
+let error ~prog fs =
+  let display str =
+    wrap ~chan:stderr (sprintf (f_"%s: error: %s") prog str);
+    prerr_newline ();
+    prerr_newline ();
+    wrap ~chan:stderr
+      (sprintf (f_"%s: If reporting bugs, run %s with debugging enabled (-v) and include the complete output.")
+         prog prog);
+    prerr_newline ();
+    exit 1
+  in
+  ksprintf display fs
+
+let feature_available (g : Guestfs.guestfs) names =
+  try g#available names; true
+  with G.Error _ -> false
+
+let read_whole_file path =
+  let buf = Buffer.create 16384 in
+  let chan = open_in path in
+  let maxlen = 16384 in
+  let s = String.create maxlen in
+  let rec loop () =
+    let r = input chan s 0 maxlen in
+    if r > 0 then (
+      Buffer.add_substring buf s 0 r;
+      loop ()
+    )
+  in
+  loop ();
+  close_in chan;
+  Buffer.contents buf
+
+(* Parse a size field, eg. "10G". *)
+let parse_size =
+  let const_re = Str.regexp "^\\([.0-9]+\\)\\([bKMG]\\)$" in
+  fun ~prog field ->
+    let matches rex = Str.string_match rex field 0 in
+    let sub i = Str.matched_group i field in
+    let size_scaled f = function
+      | "b" -> Int64.of_float f
+      | "K" -> Int64.of_float (f *. 1024.)
+      | "M" -> Int64.of_float (f *. 1024. *. 1024.)
+      | "G" -> Int64.of_float (f *. 1024. *. 1024. *. 1024.)
+      | _ -> assert false
+    in
+
+    if matches const_re then (
+      size_scaled (float_of_string (sub 1)) (sub 2)
+    )
+    else
+      error ~prog "%s: cannot parse size field" field
+
+(* Parse a size field, eg. "10G", "+20%" etc.  Used particularly by
+ * virt-resize --resize and --resize-force options.
+ *)
+let parse_resize =
+  let const_re = Str.regexp "^\\([.0-9]+\\)\\([bKMG]\\)$"
+  and plus_const_re = Str.regexp "^\\+\\([.0-9]+\\)\\([bKMG]\\)$"
+  and minus_const_re = Str.regexp "^-\\([.0-9]+\\)\\([bKMG]\\)$"
+  and percent_re = Str.regexp "^\\([.0-9]+\\)%$"
+  and plus_percent_re = Str.regexp "^\\+\\([.0-9]+\\)%$"
+  and minus_percent_re = Str.regexp "^-\\([.0-9]+\\)%$"
+  in
+  fun ~prog oldsize field ->
+    let matches rex = Str.string_match rex field 0 in
+    let sub i = Str.matched_group i field in
+    let size_scaled f = function
+      | "b" -> Int64.of_float f
+      | "K" -> Int64.of_float (f *. 1024.)
+      | "M" -> Int64.of_float (f *. 1024. *. 1024.)
+      | "G" -> Int64.of_float (f *. 1024. *. 1024. *. 1024.)
+      | _ -> assert false
+    in
+
+    if matches const_re then (
+      size_scaled (float_of_string (sub 1)) (sub 2)
+    )
+    else if matches plus_const_re then (
+      let incr = size_scaled (float_of_string (sub 1)) (sub 2) in
+      oldsize +^ incr
+    )
+    else if matches minus_const_re then (
+      let incr = size_scaled (float_of_string (sub 1)) (sub 2) in
+      oldsize -^ incr
+    )
+    else if matches percent_re then (
+      let percent = Int64.of_float (10. *. float_of_string (sub 1)) in
+      oldsize *^ percent /^ 1000L
+    )
+    else if matches plus_percent_re then (
+      let percent = Int64.of_float (10. *. float_of_string (sub 1)) in
+      oldsize +^ oldsize *^ percent /^ 1000L
+    )
+    else if matches minus_percent_re then (
+      let percent = Int64.of_float (10. *. float_of_string (sub 1)) in
+      oldsize -^ oldsize *^ percent /^ 1000L
+    )
+    else
+      error ~prog "%s: cannot parse resize field" field
+
+let human_size i =
+  let sign, i = if i < 0L then "-", Int64.neg i else "", i in
+
+  if i < 1024L then
+    sprintf "%s%Ld" sign i
+  else (
+    let f = Int64.to_float i /. 1024. in
+    let i = i /^ 1024L in
+    if i < 1024L then
+      sprintf "%s%.1fK" sign f
+    else (
+      let f = Int64.to_float i /. 1024. in
+      let i = i /^ 1024L in
+      if i < 1024L then
+        sprintf "%s%.1fM" sign f
+      else (
+        let f = Int64.to_float i /. 1024. in
+        (*let i = i /^ 1024L in*)
+        sprintf "%s%.1fG" sign f
+      )
+    )
+  )
+
+(* Skip any leading '-' characters when comparing command line args. *)
+let skip_dashes str =
+  let n = String.length str in
+  let rec loop i =
+    if i >= n then invalid_arg "skip_dashes"
+    else if String.unsafe_get str i = '-' then loop (i+1)
+    else i
+  in
+  let i = loop 0 in
+  if i = 0 then str
+  else String.sub str i (n-i)
+
+let compare_command_line_args a b =
+  compare (String.lowercase (skip_dashes a)) (String.lowercase (skip_dashes b))
+
+(* Implements `--long-options'. *)
+let long_options = ref ([] : (Arg.key * Arg.spec * Arg.doc) list)
+let display_long_options () =
+  List.iter (
+    fun (arg, _, _) ->
+      if string_prefix arg "--" && arg <> "--long-options" then
+        printf "%s\n" arg
+  ) !long_options;
+  exit 0
+
+(* Run an external command, slurp up the output as a list of lines. *)
+let external_command ~prog cmd =
+  let chan = Unix.open_process_in cmd in
+  let lines = ref [] in
+  (try while true do lines := input_line chan :: !lines done
+   with End_of_file -> ());
+  let lines = List.rev !lines in
+  let stat = Unix.close_process_in chan in
+  (match stat with
+  | Unix.WEXITED 0 -> ()
+  | Unix.WEXITED i ->
+    error ~prog (f_"external command '%s' exited with error %d") cmd i
+  | Unix.WSIGNALED i ->
+    error ~prog (f_"external command '%s' killed by signal %d") cmd i
+  | Unix.WSTOPPED i ->
+    error ~prog (f_"external command '%s' stopped by signal %d") cmd i
+  );
+  lines
+
+(* Run uuidgen to return a random UUID. *)
+let uuidgen ~prog () =
+  let lines = external_command ~prog "uuidgen -r" in
+  assert (List.length lines >= 1);
+  let uuid = List.hd lines in
+  let len = String.length uuid in
+  let uuid, len =
+    if len > 0 && uuid.[len-1] = '\n' then
+      String.sub uuid 0 (len-1), len-1
+    else
+      uuid, len in
+  if len < 10 then assert false; (* sanity check on uuidgen *)
+  uuid
+
+(* Unlink a temporary file on exit. *)
+let unlink_on_exit =
+  let files = ref [] in
+  let registered_handlers = ref false in
+
+  let rec unlink_files () =
+    List.iter (
+      fun file -> try Unix.unlink file with _ -> ()
+    ) !files
+  and register_handlers () =
+    (* Unlink on exit. *)
+    at_exit unlink_files
+  in
+
+  fun file ->
+    files := file :: !files;
+    if not !registered_handlers then (
+      register_handlers ();
+      registered_handlers := true
+    )
+
+(* Using the libguestfs API, recursively remove only files from the
+ * given directory.  Useful for cleaning /var/cache etc in sysprep
+ * without removing the actual directory structure.  Also if 'dir' is
+ * not a directory or doesn't exist, ignore it.
+ *
+ * XXX Could be faster with a specific API for doing this.
+ *)
+let rm_rf_only_files (g : Guestfs.guestfs) dir =
+  if g#is_dir dir then (
+    let files = Array.map (Filename.concat dir) (g#find dir) in
+    let files = Array.to_list files in
+    let files = List.filter g#is_file files in
+    List.iter g#rm files
+  )
+
+let is_char_device file =
+  try (Unix.stat file).Unix.st_kind = Unix.S_CHR
+  with Unix.Unix_error _ -> false
diff --git a/mllib/common_utils_tests.ml b/mllib/common_utils_tests.ml
new file mode 100644
index 0000000..e06b3a4
--- /dev/null
+++ b/mllib/common_utils_tests.ml
@@ -0,0 +1,80 @@
+(* virt-resize
+ * Copyright (C) 2011 Red Hat Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ *)
+
+(* This file tests the Common_utils module. *)
+
+open Common_utils
+
+let prog = "common_utils_tests"
+
+(* Test Common_utils.int_of_le32 and Common_utils.le32_of_int. *)
+let () =
+  assert (int_of_le32 "\x80\x60\x40\x20" = 0x20406080L);
+  assert (le32_of_int 0x20406080L = "\x80\x60\x40\x20")
+
+(* Test Common_utils.parse_size. *)
+let () =
+  (* For absolute sizes, oldsize is ignored. *)
+  assert (parse_resize ~prog 100_L "100b" = 100_L);
+  assert (parse_resize ~prog 1000_L "100b" = 100_L);
+  assert (parse_resize ~prog 10000_L "100b" = 100_L);
+  assert (parse_resize ~prog 100_L "100K" = 102400_L);
+  (* Fractions are always rounded down. *)
+  assert (parse_resize ~prog 100_L "1.1K" = 1126_L);
+  assert (parse_resize ~prog 100_L "100.1M" = 104962457_L);
+  assert (parse_resize ~prog 100_L "123.4G" = 132499741081_L);
+
+  (* oldsize +/- a constant. *)
+  assert (parse_resize ~prog 100_L "+1b" = 101_L);
+  assert (parse_resize ~prog 100_L "-2b" = 98_L);
+  assert (parse_resize ~prog 100_L "+1K" = 1124_L);
+  assert (parse_resize ~prog 1024_L "-1K" = 0_L);
+  assert (parse_resize ~prog 1126_L "-1.1K" = 0_L);
+  assert (parse_resize ~prog 1024_L "+1.1M" = 1154457_L);
+  assert (parse_resize ~prog 132499741081_L "-123.3G" = 107374182_L);
+
+  (* oldsize +/- a percentage. *)
+  assert (parse_resize ~prog 100_L "+1%" = 101_L);
+  assert (parse_resize ~prog 100_L "-1%" = 99_L);
+  assert (parse_resize ~prog 100000_L "+1%" = 101000_L);
+  assert (parse_resize ~prog 100000_L "-1%" = 99000_L);
+  assert (parse_resize ~prog 100000_L "+50%" = 150000_L);
+  assert (parse_resize ~prog 100000_L "-50%" = 50000_L);
+  assert (parse_resize ~prog 100000_L "+100%" = 200000_L);
+  assert (parse_resize ~prog 100000_L "-100%" = 0_L);
+  assert (parse_resize ~prog 100000_L "+200%" = 300000_L);
+  assert (parse_resize ~prog 100000_L "+300%" = 400000_L);
+
+  (* Implementation rounds numbers so that only a single digit after
+   * the decimal point is significant.
+   *)
+  assert (parse_resize ~prog 100000_L "+1.1%" = 101100_L);
+  assert (parse_resize ~prog 100000_L "+1.12%" = 101100_L)
+
+(* Test Common_utils.human_size. *)
+let () =
+  assert (human_size 100_L = "100");
+  assert (human_size (-100_L) = "-100");
+  assert (human_size 1024_L = "1.0K");
+  assert (human_size (-1024_L) = "-1.0K");
+  assert (human_size 1126_L = "1.1K");
+  assert (human_size (-1126_L) = "-1.1K");
+  assert (human_size 1363149_L = "1.3M");
+  assert (human_size (-1363149_L) = "-1.3M");
+  assert (human_size 3650722201_L = "3.4G");
+  assert (human_size (-3650722201_L) = "-3.4G")
